summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2010-11-10 14:35:17 +0000
committerPádraig Brady <P@draigBrady.com>2010-11-11 01:40:12 +0000
commit0339eb4598600024cedca14a7e882c1737dd2d82 (patch)
treea83d8af40ed3fa2382f8720c0f74aaa8fad644f3 /tests
parent7727908335ef1049deac42851026ed8bf5ae2734 (diff)
downloadcoreutils-0339eb4598600024cedca14a7e882c1737dd2d82.tar.xz
csplit: fix a memory leak per input buffer
* src/csplit.c (free_buffer): Also free the line offsets buffers (remove_line): Also free the containing structure * tests/misc/csplit-heap: A new test to trigger with leaks of this magnitude. * tests/Makefile.am: Reference the new test * NEWS: Mention the fix Reported by David Hofstee
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/misc/csplit-heap29
2 files changed, 30 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index a3a30b6bd..90ff292a1 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -173,6 +173,7 @@ TESTS = \
misc/comm \
misc/csplit \
misc/csplit-1000 \
+ misc/csplit-heap \
misc/date-sec \
misc/dircolors \
misc/df \
diff --git a/tests/misc/csplit-heap b/tests/misc/csplit-heap
new file mode 100755
index 000000000..0e7f8b2ef
--- /dev/null
+++ b/tests/misc/csplit-heap
@@ -0,0 +1,29 @@
+#!/bin/sh
+# ensure that csplit uses a bounded amount of memory
+
+# Copyright (C) 2010 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+test "$VERBOSE" = yes && csplit --version
+
+require_ulimit_
+
+(
+ ulimit -v 20000
+ { yes | head -n2500000; echo n; } | csplit -z - %n%1
+) || fail=1
+
+Exit $fail